; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 530
WINDOWHEIGHT = 553

RGBQUAD		struct
  rgbBlue       db ?
  rgbGreen      db ?
  rgbRed        db ?
  rgbReserved	db ?
RGBQUAD		ends

BITMAPFILEHEADER	struct
  bfType		dw ?
  bfSize		dd ?
  bfReserved1		dw ?
  bfReserved2		dw ?
  bfOffBits		dd ?
BITMAPFILEHEADER	ends

BITMAPINFOHEADER	struct
  biSize		dd ?;+0
  biWidth		dd ?;+4
  biHeight		dd ?;+8
  biPlanes		dw ?;+12
  biBitCount		dw ?;+14
  biCompression		dd ?;+16
  biSizeImage		dd ?;+20
  biXPelsPerMeter	dd ?;+24
  biYPelsPerMeter	dd ?;+28
  biClrUsed		dd ?;+32
  biClrImportant	dd ?;+36
BITMAPINFOHEADER	ends;40

AVISTREAMINFOA		struct
  fccType		dd ?
  fccHandler		dd ?
  dwFlags		dd ?
  dwCaps		dd ?
  wPriority		dw ?
  wLanguage		dw ?
  dwScale		dd ?
  dwRate		dd ?
  dwStart		dd ?
  dwLength		dd ?
  dwInitialFrames	dd ?
  dwSuggestedBufferSize	dd ?
  dwQuality		dd ?
  dwSampleSize		dd ?
  rcFrame		RECT <>
  dwEditCount		dd ?
  dwFormatChangeCount	dd ?
  szName		db 64 dup(?)
AVISTREAMINFOA		ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset fmt;szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword


        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	DeleteObject,hBitmap; Delete the device dependant bitmap object
	invoke	DrawDibClose,hdd; Closes the drawDib device context
	invoke	AVIStreamGetFrameClose,pgf	; Deallocates the GetFrame resources
	invoke	AVIStreamRelease,pavi; Release the stream
	invoke	AVIFileExit	; Release the file
	invoke	RtlExitUserProcess,NULL

wmTIMER:movss	xmm0,angle
	cvtsi2ss xmm1,mpf
	divss	xmm1,const60
	addss	xmm0,xmm1
	movss	angle,xmm0; Update angle Based On The Timer
	mov	eax,next
	add	eax,mpf; Increase next Based On The Timer
	mov	next,eax
	xor	edx,edx
	div	mpf
	mov	frame0,eax; Calculate The Current Frame
	cmp	eax,lastframe
	jb	@f
	and	frame0,0;	; Reset The Frame Back To Zero (Start Of Video)
	and	next,0;		; Reset The Animation Timer (next)
@@:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_SPACE
	jne	@f
	inc	effect; Change Effects (Increase effect)
	and	effect,3; Over Our Limit? Reset Back To 0
	jmp	@0
@@:	cmp	al,VK_PRIOR
	jne	@f
	movss	xmm0,const_0_02;        z-=0.02
	jmp	@1
@@:	cmp	al,VK_NEXT
	jne	@f
	movd	xmm0,const0_02;        z+=0.02
@1:	addss	xmm0,z
	movd	z,xmm0
	jmp	@0
@@:	cmp	al,VK_B;'B' is pressing
	jne	@f
	xor	bg,1; Toggle Background Off/On
	jmp	@0
@@:	cmp	al,VK_E;'E' is pressing
	jne	wmBYE
	xor	env,1;Toggle Environment Mapping Off/On
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	CreateCompatibleDC,0
	mov	hdc,rax
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; (0.0f, 0.0f, 0.0f, 0.5f; Black background
        movsd	xmm0,constd1
	invoke	glClearDepth; Depth buffer setup
	invoke	glDepthFunc,GL_LEQUAL; The type of depth testing (Less or equal)
	invoke	glEnable,GL_DEPTH_TEST; Enable depth testing
	invoke	glShadeModel,GL_SMOOTH; Select smooth shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set perspective calculations to most accurate
	invoke	gluNewQuadric
	mov	quadratic,rax; Create a pointer to the quadric object
	invoke	gluQuadricNormals,eax, GLU_SMOOTH; Create smooth normals
	invoke	gluQuadricTexture,quadratic, GL_TRUE; Create texture coords

	invoke	glEnable,GL_TEXTURE_2D; Enable texture mapping
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST; Set texture max filter
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST; Set texture min filter

	invoke	glTexGeni,GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP; Set the texture generation mode for S to sphere mapping
	invoke	glTexGeni,GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP; Set the texture generation mode for T to sphere mapping
; Open the AVI file
	invoke	OpenAVI,hWin
; Create the texture
	mov	eax,data_
	mov	[rsp+40h],rax
	mov	r9d,256
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,,r9,rdx,r8,GL_UNSIGNED_BYTE
	mov	r8d,mpf
	invoke	SetTimer,hWin,10,,0;  #10  25mSec
;---------------------------------------------------------
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
        invoke	DrawDibOpen
	mov	hdd,rax; Grab a device context for our dib
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
;Grabs a Frame from the Stream--------------------------------
	mov	edx,frame0
	invoke	AVIStreamGetFrame,pgf; Grab Data From The AVI Stream
	mov	[rsp+30h],rax; Holds The Bitmap Header Information
	mov	ecx,eax

	mov	eax,[rcx].BITMAPINFOHEADER.biSize
	add	eax,ecx
	mov	edx,[rcx].BITMAPINFOHEADER.biClrUsed
	imul	edx,sizeof RGBQUAD
	add	eax,edx
	mov	pdata,rax;pdata	=  lpbi + lpbi->biSize + lpbi->biClrUsed * sizeof(RGBQUAD)
	mov	[rsp+38h],rax
	mov	eax,256
	mov	[rsp+20h],rax
	mov	[rsp+28h],rax
	invoke	DrawDibDraw,hdd,hdc,0,0,,,,,0,0,width_,height,0; Grab A Frame From The AVI
	mov	eax,256
	mov	[rsp+20h],rax
	mov	[rsp+28h],rax
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,data_
	mov	[rsp+40h],rax
	invoke	glTexSubImage2D,GL_TEXTURE_2D,0,0,0;

	invoke	glLoadIdentity ; Reset The Modelview Matrix
;     (z=-10)
	movd	xmm2,z;const_10
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef

@@:	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,angle
	mulss	xmm0,const2_3
	invoke	glRotatef
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,angle
	mulss	xmm0,const1_8
	invoke	glRotatef
	movss	xmm2,const2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,2; After Rotating Translate To New Position
;-------------------------------------------------------
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,angle
	mulss	xmm0,const1_3
	invoke	glRotatef;angle*1.3, 1, 0, 0	 Rotate On The X-Axis By angle
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,angle
	mulss	xmm0,const1_1
	invoke	glRotatef;angle*1.1, 0, 1, 0	 Rotate On The Y-Axis By angle
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,angle
	mulss	xmm0,const1_2
	invoke	glRotatef;angle*1.2, 0, 0, 1	; Rotate On The Z-Axis By angle
;---------------------------------------------------------------
	cmp	env,0
	jz	@f
	invoke	glEnable,GL_TEXTURE_GEN_S; Enable texture coord generation for S
	invoke	glEnable,GL_TEXTURE_GEN_T; Enable texture coord generation for T
@@:
;------------------------------------------------------------------------
        mov	eax,effect
	jmp	handler[rax*8]
case0:; Effect 0 - Cube
	invoke	glDrawCube
	jmp	@2;		; Done Effect 0
case1:; Effect 1 - Sphere
	movq	xmm1,constd1_3
	invoke	gluSphere,quadratic,,20,20; Draw A Sphere
	jmp	@2;		; Done Drawing Sphere
case2:; Effect 2 - Cylinder
	movss	xmm2,const_1_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-1.5	 Center The Cylinder
	movsd	xmm3,constd3
	movsd	xmm2,constd1
	movsd	xmm1,xmm2
	invoke	gluCylinder,quadratic,,,,32,32; Draw A Cylinder
	jmp	@2
case3:	movd	xmm2,const_1_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-1.5	 Center The Cone
	movq	xmm3,constd3
	xorps	xmm2,xmm2
	movq	xmm1,constd1
	invoke	gluCylinder,quadratic,,,,32,32; A Cone With A Bottom Radius Of .5 And A Height Of 2
@2:
;-----------------------------------
	cmp	env,0; Environment mapping enabled?
	jz	@f
	invoke	glDisable,GL_TEXTURE_GEN_S; Disable texture coord generation for S
	invoke	glDisable,GL_TEXTURE_GEN_T; Disable texture coord generation for T
@@:
;-----------------------------------------
	cmp	bg,0
	jz	@f
	invoke	glLoadIdentity		; Reset The Modelview Matrix
	invoke	glBegin,GL_QUADS	; Begin Drawing The Background (One Quad)
; Front Face
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1 
	movd	xmm2,const_20
	movd	xmm1,const8_3
	movd	xmm0,const11
	invoke	glVertex3f;11, 8.3,-20
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1 
	movd	xmm2,const_20
	movd	xmm1,const8_3
	movd	xmm0,const_11
	invoke	glVertex3f;-11, 8.3,-20.0
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	movd	xmm2,const_20
	movd	xmm1,const_8_3
	movd	xmm0,const_11
	invoke	glVertex3f;-11,-8.3,-20
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1, 0); 
	movd	xmm2,const_20
	movd	xmm1,const_8_3
	movd	xmm0,const11
	invoke	glVertex3f;11,-8.3,-20
	invoke	glEnd	; Done Drawing The Background
@@:
;----------------------------------------------------------------	
	invoke	glFlush ; Flush The GL Rendering Pipeline
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
;---------------------------------------
wmBYE:	leave
	retn
handler dq case0,case1,case2,case3
WndProc	endp
glDrawCube proc
        enter	20h,0
	invoke	glBegin,GL_QUADS;		; Begin Drawing A Cube
; Front Face
	movss	xmm2,const0_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0, 1     //    
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTexCoord2f;0,0
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1,-1,1
	xorps	xmm1,xmm1
	movss	xmm0,const1
        invoke	glTexCoord2f;1,0
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f;1,-1,1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;1, 1, 1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f; 0,1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f;-1, 1, 1
; Back Face
	movss	xmm2,const_0_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0,-1     //    
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f; 1,0
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,-1,-1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f; 1,1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,1,-1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f;1,1,-1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f; 1,-1,-1
; Top Face
	xorps	xmm2,xmm2
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 1, 0);     //   
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f ;0,1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1, 1,-1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f;-1, 1, 1
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;1,1, 1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1,-1, 1
; Bottom Face
	xorps	xmm2,xmm2
	movss	xmm1,const_0_5
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0,-1, 0);     //   
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; -1,-1,-1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f;-1,1,1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f;1, -1,1
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f; -1, -1,1
; Right Face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const0_5
	invoke	glNormal3f;1, 0, 0	   
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f;1, -1, -1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f;1, 1,-1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;1,1,1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f;1,-1, 1
; Left Face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_0_5
	invoke	glNormal3f;-1, 0, 0	   
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; -1, -1,-1
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1,0
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f; -1, -1, 1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f; -1,1, 1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,1,-1
	invoke	glEnd;	; Done Drawing Our Cube
	leave
	ret
glDrawCube endp
OpenAVI proc	hWnd:dword
local	buffer[100]:byte;Will Hold The Modified Window Title

	mov	hWnd,ecx

	invoke	AVIFileInit; Opens the AVIFile library
; Opens the AVI stream
	mov	ecx,offset pavi
	mov	edx,offset FileName2
	mov	r8d,"sdiv";streamtypeVIDEO='vids'
	xor	r9d,r9d
	invoke	AVIStreamOpenFromFile,,,,,rbx,rbx

	mov	edx,offset psi
	invoke	AVIStreamInfo,pavi,,sizeof psi;	; Reads information about the stream into psi
	mov	eax,psi.rcFrame.right
	sub	eax,psi.rcFrame.left
	mov	width_,rax;Width Is Right Side Of Frame Minus Left
	mov	eax,psi.rcFrame.bottom
	sub	eax,psi.rcFrame.top
	mov	height,rax;Height Is Bottom of Frame Minus Top
	invoke	AVIStreamLength,pavi
	mov	lastframe,eax;The Last Frame of the Stream
	invoke	AVIStreamSampleToTime,pavi,1;eax
	mov	mpf,eax;Calculate Rough Milliseconds per Frame

	sub	esp,sizeof BITMAPINFOHEADER+8
	mov	edx,esp;offset bmih
	mov	[rdx].BITMAPINFOHEADER.biSize,sizeof BITMAPINFOHEADER;Size of The BitmapInfoHeader
	mov	[rdx].BITMAPINFOHEADER.biPlanes,1; Bitplanes	
	mov	[rdx].BITMAPINFOHEADER.biBitCount,24; Bits Format We Want (24 Bit, 3 Bytes)
	mov	[rdx].BITMAPINFOHEADER.biWidth,256; Width We Want (in Pixels)
	mov	[rdx].BITMAPINFOHEADER.biHeight,256; Height We Want (in Pixels)
	mov	[rdx].BITMAPINFOHEADER.biCompression,ebx;BI_RGB=0;Requested Mode = RGB
	mov	r9d,offset data_
	invoke	CreateDIBSection,hdc,,DIB_RGB_COLORS,,rbx,rbx
	mov	hBitmap,rax
	invoke	SelectObject,hdc,eax;Select hBitmap Into Our Device Context (hDC)
	invoke	AVIStreamGetFrameOpen,pavi,0;Create The PGETFRAME	Using Our Request Mode
	mov	pgf,rax
; Information for the title bar (Width / height / last frame)
	lea	ecx,buffer
	mov	edx,offset fmt
	mov	eax,lastframe
	mov	[rsp+20h],rax
	invoke	wsprintf,,,width_,height
	lea	edx,buffer
	invoke	SetWindowText,hWnd;Modify The Title Bar
	leave
	ret
OpenAVI endp
;------------------------------------------------------------
hDC	dq	?
hdc	dq	?
memDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	24;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

FileName	db "br_Rabbit3.cur",0
FileName2	db "movie0.avi",0
fmt		db "NeHe's AVI Player: Width: %d, Height: %d, Frames: %d",0
; User Defined Variables
angle		dd 0;	; Used for rotation
next		dd ?;	; Used for animation
frame0		dd 0;	; Frame counter
effect		dd 0;	; Current effect
env		db TRUE ; Environment mapping (Default on)
bg		db TRUE	; Background (Default on)
pavi		dq ?; Handle to an open stream
pgf		dq ?	; Pointer to a getframe object
lastframe	dd ?	; Last frame of the stream
width_		dq ?	; Video width
height		dq ?	; Video height
pdata		dq ?	; Pointer to texture data
mpf		dd ?	; Will hold rough milliseconds per frame
quadratic	dq ?	; Storage for our quadratic objects
hdd		dq ?;	; Handle for our dib
hBitmap		HBITMAP ?; Handle to a device dependant bitmap
data_		dd 0;	; Pointer to our resized image
psi		AVISTREAMINFOA <>; Pointer to a structure containing stream info
z		dd -10.0; Depth Into The Screen
;-----------------------------
;float
const_0_02	dd -0.02
const0_02	dd 0.02
const0_5	dd 0.5
const_0_5	dd -0.5
const1		dd 1.0
const_1		dd -1.0
const1_1	dd 1.1
const1_2	dd 1.2
const1_3	dd 1.3
const_1_5	dd -1.5
const1_8	dd 1.8
const2		dd 2.0
const2_3	dd 2.3
const8_3	dd 8.3
const_8_3	dd -8.3
const11		dd 11.0
const_11	dd -11.0
const_20	dd -20.0
const60		dd 60.0
;double
constd1		dq 1.0
constd1_3	dq 1.3
constd3		dq 3.0
constd45	dq 45.0
constd100	dq 100.0
end